// VARS AND OBJECTS

global.posSave_buffer = buffer_create();
global.posSave_packetId = argument1;

global.posSave_SAVE_POS = 200;
global.posSave_LOAD_POS = 199;

ini_open("gg2.ini");
global.posSave_saveKey = ini_read_real("Plugins", "posSave_saveKey", -1);
global.posSave_loadKey = ini_read_real("Plugins", "posSave_loadKey", -1);
ini_close();

global.posSave_Controller = object_add();
object_set_persistent(global.posSave_Controller, true);

global.posSave_Menu = object_add();
object_set_parent(global.posSave_Menu, InGameMenuController);
object_set_depth(global.posSave_Menu, -130000);



// INIT SCRIPT
//

// Player: enable plugin attributes
// done in ev_step because according to lorgan server-sent plugins do weird things on startup
object_event_add(Player,ev_create,0,'
	posSave_x = -1;
	posSave_y = -1;
');
object_event_add(Player,ev_step,ev_step_begin,'
    if !variable_local_exists("posSave_x") {
		posSave_x = -1;
		posSave_y = -1;
    }
');

object_event_add(PlayerControl,ev_step,ev_step_begin,'
	object_exists(global.posSave_Controller) {
		if(not instance_exists(global.posSave_Controller)) {
			instance_create(0,0,global.posSave_Controller);
		}
	}
');




// MENU SCRIPT
//

if !variable_global_exists("pluginOptions") {
    global.pluginOptions = object_add();
    object_set_parent(global.pluginOptions,OptionsController);  
    object_set_depth(global.pluginOptions,-130000);
    object_event_add(global.pluginOptions,ev_create,0,'   
        menu_create(40, 140, 300, 200, 30);
		
        if (room != Options)
            menu_setdimmed();
			
        menu_addback("Back", "
            instance_destroy();
            if(room == Options)
                instance_create(0,0,MainMenuController);
            else
                instance_create(0,0,InGameMenuController);
        ");
    ');
    
    object_event_add(InGameMenuController,ev_create,0,'
        menu_addlink("Plugin Options", "
            instance_destroy();
            instance_create(0,0,global.pluginOptions);
        ");
    ');
} 

object_event_add(global.pluginOptions, ev_create, 0, '
	menu_addlink("Position save", "
		instance_destroy();
		instance_create(0,0,global.posSave_Menu);
	");
');

object_event_add(global.posSave_Menu,ev_create,0,'   
	menu_create(40, 140, 300, 200, 30);
	menu_setdimmed();
	
	menu_addlink("Save current position", global.posSave_saveScript);
	menu_addlink("Load saved position", global.posSave_loadScript);
	menu_addlink("","");
	
    menu_addedit_key("Save pos shortcut", "global.posSave_saveKey");
    menu_addedit_key("Load pos shortcut", "global.posSave_loadKey");
		
	menu_addback("Back", "
		instance_destroy();
		instance_create(0,0,global.pluginOptions);
	");
');

object_event_add(global.posSave_Menu,ev_destroy,0,'
	ini_open("gg2.ini");
    ini_write_real("Plugins", "posSave_saveKey", global.posSave_saveKey);
    ini_write_real("Plugins", "posSave_loadKey", global.posSave_loadKey);
	ini_close();
');



// NETWORKING SCRIPTS
//

object_event_add(global.posSave_Controller, ev_step, ev_step_normal, '
	// Only the host needs to check networking things 
	// xs and ys are already synced
	if(global.isHost) {
		var receiveBuffer;
		receiveBuffer = PluginPacketGetBuffer(global.posSave_packetId);
		while(receiveBuffer != -1) {
			var data;
			paramPlayer = PluginPacketGetPlayer(global.posSave_packetId);
			data = read_ubyte(receiveBuffer);
			
			switch(data) {
				case global.posSave_SAVE_POS:
					event_user(2);
					break;
				case global.posSave_LOAD_POS:
					event_user(3);
					break;
			}
			
			paramPlayer = noone;
			buffer_clear(receiveBuffer);
			PluginPacketPop(global.posSave_packetId);
			receiveBuffer = PluginPacketGetBuffer(global.posSave_packetId);
		}
	}
');

global.posSave_netScriptBegin = '
	var sendBuffer;
	sendBuffer = buffer_create();
';
global.posSave_netScriptEnd = '
	PluginPacketSend(global.posSave_packetId, sendBuffer);
	buffer_clear(sendBuffer);
	buffer_destroy(sendBuffer);
';



// REAL SCRIPT
//
 
global.posSave_loadScript = '
	with(global.posSave_Controller) {
		if(global.isHost) {
			paramPlayer = global.myself;
			event_user(3);
			paramPlayer = noone;
		} else {
			event_user(1);
		}
	}
';

global.posSave_saveScript = '
	with(global.posSave_Controller) {
		if(global.isHost) {
			paramPlayer = global.myself;
			event_user(2);
			paramPlayer = noone;
		} else {
			event_user(0);
		}
	}
';

object_event_add(global.posSave_Controller, ev_create, 0, '
	paramPlayer = noone;	// used in networking + event_user 2 & 3
');



// Keyboard

object_event_add(global.posSave_Controller, ev_keypress, 0, '
	if(not instance_exists(InGameMenuController)) {
		if(global.posSave_saveKey != -1) {
			if(keyboard_check_pressed(global.posSave_saveKey) || keyboard_check_released(global.posSave_saveKey)) {
				' + global.posSave_saveScript + '
			}
		}
		if(global.posSave_loadKey != -1) {
			if(keyboard_check_pressed(global.posSave_loadKey) || keyboard_check_released(global.posSave_loadKey)) {
				' + global.posSave_loadScript + '
			}
		}
	}
');




// USER EVENTS
//
// Say to server you're saving your pos
object_event_add(global.posSave_Controller, ev_other, ev_user0, 
	global.posSave_netScriptBegin + '
	
		write_ubyte(sendBuffer, global.posSave_SAVE_POS);
		
	' + global.posSave_netScriptEnd
);


// Say to server you're loading your pos
object_event_add(global.posSave_Controller, ev_other, ev_user1, 
	global.posSave_netScriptBegin + '
	
		write_ubyte(sendBuffer, global.posSave_LOAD_POS);
		
	' + global.posSave_netScriptEnd
);


// As server, save a pos
object_event_add(global.posSave_Controller, ev_other, ev_user2, '
	if(paramPlayer.object != -1) {
		with(paramPlayer) {
			posSave_x = object.x;
			posSave_y = object.y;
		}
	}
');


// As server, load a pos
object_event_add(global.posSave_Controller, ev_other, ev_user3, '
	if(paramPlayer.object != -1) {
		with(paramPlayer) {
			object.x = posSave_x;
			object.y = posSave_y;
		}
	}
');



// ROOM CHANGES
// Reset players pos to prevent being stuck in impossible places and shit
//
object_event_add(RoomChangeObserver, ev_other, ev_room_start, '
	with(Player) {
		posSave_x = -1;
		posSave_y = -1;
	}
');